unit BC_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls , StdCtrls , ShellAPI , ShlObj , ActiveX , COMObj , ClipBrd ,
  ToolWin, ImgList, ExtCtrls, Spin, ScktComp ;

type
  TClientStatus = (CS_UnKnown , CS_Disconnected , CS_Ready  , CS_Join   , CS_Playing , CS_Pause , CS_Ordering , CS_GameOver);
  TPlayerType   = (PT_Unknown , PT_Factory      , PT_Whole1 , PT_Whole2 , PT_Retail);

 // ӎv藚̌^
  TPlayHistory = packed record
    FtStock  : Byte;
    W1Stock  : Byte;
    W2Stock  : Byte;
    RtStock  : Byte;
    BackLog  : Byte;
    Demand   : Byte;
    Order    : ShortInt;
    Shipment : ShortInt;
  end;

  TBeerGameClientForm = class(TForm)
    ClientSocket : TClientSocket;
    StatusBar    : TStatusBar;
    SaveDialog   : TSaveDialog;
    FontDialog   : TFontDialog;
    PageControl  : TPageControl;
   // j[n
    MainMenu      : TMainMenu;
    Menu_Game     : TMenuItem;
    MItem_Order   : TMenuItem;
    M_Separator1  : TMenuItem;
    MItem_Connect : TMenuItem;
    MItem_SendMsg : TMenuItem;
    M_Separator2  : TMenuItem;
    MItem_Save    : TMenuItem;
    M_Separator3  : TMenuItem;
    MItem_Exit    : TMenuItem;
   // ҏW
    Menu_Edit    : TMenuItem;
    MItem_Copy   : TMenuItem;
    MItem_SelAll : TMenuItem;
    M_Separator4 : TMenuItem;
    MItem_Font   : TMenuItem;
   // wv
    Menu_Help          : TMenuItem;
    MItem_StartUp      : TMenuItem;
    MItem_StayFront    : TMenuItem;
    MItem_TaskTray     : TMenuItem;
    MItem_CloseCheck   : TMenuItem;
    M_Separator5       : TMenuItem;
    MItem_History      : TMenuItem;
    MItem_Doc          : TMenuItem;
    M_Separator6       : TMenuItem;
    MItem_Info         : TMenuItem;
    PopupMenu_ListView : TPopupMenu;
    PItem_Copy         : TMenuItem;
    PItem_SelAll       : TMenuItem;
    P_Separator2       : TMenuItem;
    PItem_Save         : TMenuItem;
   // ڑ^u
    TabSheet_Connect  : TTabSheet;
    GroupBox_Server   : TGroupBox;
    CheckBox_Connect  : TCheckBox;
    Label_Server      : TLabel;
    Label_Port        : TLabel;
    Edit_Server       : TEdit;
    SpinEdit_Port     : TSpinEdit;
    GroupBox_Name     : TGroupBox;
    Edit_Name         : TEdit;
    RadioGroup_Play   : TRadioGroup;
    GroupBox_Join     : TGroupBox;
    Label_FtJoin      : TLabel;
    Label_W1Join      : TLabel;
    Label_W2Join      : TLabel;
    Label_RtJoin      : TLabel;
    Label_Msg         : TLabel;
    Memo_Msg          : TMemo;
    RadioGroup_Target : TRadioGroup;
    Button_SendMsg    : TButton;
   // Q[^u
    TabSheet_Game    : TTabSheet;
    GroupBox_Game    : TGroupBox;
    Label_Factory    : TLabel;
    Label_Whole1     : TLabel;
    Label_Whole2     : TLabel;
    Label_Retail     : TLabel;
    Label_Marcket    : TLabel;
    Label_Cursor1    : TLabel;
    Label_Cursor2    : TLabel;
    Label_Cursor3    : TLabel;
    Label_Cursor4    : TLabel;
    Label_FtStock    : TLabel;
    Label_W1Stock    : TLabel;
    Label_W2Stock    : TLabel;
    Label_RtStock    : TLabel;
    Label_FtBLCost   : TLabel;
    Label_W1BLCost   : TLabel;
    Label_W2BLCost   : TLabel;
    Label_RtBLCost   : TLabel;
    Label_FtDemand   : TLabel;
    Label_W1Demand   : TLabel;
    Label_W2Demand   : TLabel;
    Label_RtDemand   : TLabel;
    Label_FtOrder    : TLabel;
    Label_W1Order    : TLabel;
    Label_W2Order    : TLabel;
    Label_RtOrder    : TLabel;
    Label_RtShipM    : TLabel;
    Label_W2ShipM    : TLabel;
    Label_W1ShipM    : TLabel;
    Label_FtShipM    : TLabel;
    SpinEdit_FtOrder : TSpinEdit;
    SpinEdit_W1Order : TSpinEdit;
    SpinEdit_W2Order : TSpinEdit;
    SpinEdit_RtOrder : TSpinEdit;
    SpinEdit_FtShipM : TSpinEdit;
    SpinEdit_W1ShipM : TSpinEdit;
    SpinEdit_W2ShipM : TSpinEdit;
    SpinEdit_RtShipM : TSpinEdit;
    Button_FtOrder   : TButton;
    Button_W1Order   : TButton;
    Button_W2Order   : TButton;
    Button_RtOrder   : TButton;
    GroupBox_Input   : TGroupBox;
    Label_FtInput    : TLabel;
    Label_W1Input    : TLabel;
    Label_W2Input    : TLabel;
    Label_RtInput    : TLabel;
   // ^u
    TabSheet_History : TTabSheet;
    Label_History    : TLabel;
    ListView_History : TListView;
    procedure WndProc           (var Message : TMessage); override;
    procedure FormCreate             (Sender : TObject);
    procedure FormCloseQuery         (Sender : TObject; var CanClose : Boolean);
    procedure ClientSocketConnect    (Sender : TObject; Socket : TCustomWinSocket);
    procedure ClientSocketDisconnect (Sender : TObject; Socket : TCustomWinSocket);
    procedure ClientSocketError      (Sender : TObject; Socket : TCustomWinSocket; ErrorEvent : TErrorEvent; var ErrorCode : Integer);
    procedure ClientSocketRead       (Sender : TObject; Socket : TCustomWinSocket);
    procedure Menu_GameClick         (Sender : TObject);
    procedure Menu_EditClick         (Sender : TObject);
    procedure Menu_HelpClick         (Sender : TObject);
    procedure PopupMenu_ListViewPopup(Sender : TObject);
    procedure MItem_ConnectClick     (Sender : TObject);
    procedure MItem_SaveClick        (Sender : TObject);
    procedure MItem_ExitClick        (Sender : TObject);
    procedure MItem_CopyClick        (Sender : TObject);
    procedure MItem_SelAllClick      (Sender : TObject);
    procedure MItem_FontClick        (Sender : TObject);
    procedure MItem_StartUpClick     (Sender : TObject);
    procedure MItem_CheckClick       (Sender : TObject);
    procedure MItem_DocClick         (Sender : TObject);
    procedure MItem_HistoryClick     (Sender : TObject);
    procedure MItem_InfoClick        (Sender : TObject);
   // tH[
    procedure SpinEdit_Exit          (Sender : TObject);
    procedure CheckBox_ConnectClick  (Sender : TObject);
    procedure RadioGroup_PlayClick   (Sender : TObject);
    procedure Button_OrderClick      (Sender : TObject);
    procedure Button_SendMsgClick    (Sender : TObject);
    procedure ListView_KeyDown       (Sender : TObject; var Key : Word; Shift : TShiftState);
  //  procedure GroupBox_NameClick(Sender: TObject);
  private
   // ʌn
    FInTaskTray : Boolean;
    FNotifyIcon : TNotifyIconData;
   // ŗLn
    FPlayHistory  : array of TPlayHistory; // s
    FClientStatus : TClientStatus;         // Q[
    FShowJoinDiag : Boolean; // QF܂̕\tO
    FHandShipment : Boolean; // True͔̎zw蓮ōs
    FNowTurn      : ShortInt;
    FGroupName    : String;
    FReceivedMsg  : String;  // MbZ[W
    FFactory_Stk  : Byte;    // ̃^[ŎMe
    FWhole1_Stk   : Byte;
    FWhole2_Stk   : Byte;
    FRetail_Stk   : Byte;
    FBackLog      : Byte;
    FDemand       : Byte;
    FOrder        : ShortInt;
    FShipment     : ShortInt;
    FFtEntry      : Boolean; // ev[Qςǂ
    FW1Entry      : Boolean;
    FW2Entry      : Boolean;
    FRtEntry      : Boolean;
    FFtOrder      : Boolean; // ev[sςǂ
    FW1Order      : Boolean;
    FW2Order      : Boolean;
    FRtOrder      : Boolean;
   // ʌn
    procedure OnAppException   (Sender   : TObject; E : Exception);
    procedure OnMinimize       (Sender   : TObject);
    function  ListView_CpytoClp(ListView : TListView; ColumnDivStr : String; NotClip : Boolean = False) : String;
   // ŗLn
    procedure InitField           ();     // NXtB[h̏
    procedure ExtractMessages     (ReceivedMsgs : String);
    procedure ProcessMessages     (MsgType , MainStr : String); // ߎށA{
    procedure ClearFontStyle      ();     // ́EQ󋵃x̃tHgX^C
    procedure SetEntryLabels      ();     // Q󋵍XV
    procedure SetOrderLabels      ();     // ͏󋵍XV
    procedure RefreshUIVisible    ();     // eUIVisible̍XV
    procedure RefreshUIEnabled    ();     // eUIEnabled̍XV
    procedure LoadHistory         ();     // sListView֓Ǎ
    procedure ResultDataToListView(); // s̍vƕςListView̖ɏWv
    procedure RefreshUI           ();     // eUI̍XV(RefreshUIVisible , Enabled()ŌĂ΂)
    procedure SendText            (const Socket : TCustomWinSocket; const SendText : String; const UnitLength : Byte = 10; const DivChar : Char = #9);
  public
    FColumnDivStr : String;
    procedure InToTaskTray (IsStart : Boolean);
    procedure LeaveTaskTray();
    procedure DroppedFiles (var Msg : TWMDROPFILES);
    message   WM_DROPFILES;
  end;

const
  Version           = 'ver 1.00 beta 6E';
  Date              = ' (2006-2/14)';
  WM_NotifyTasktray = WM_USER + 100;
  TaskTrayMsg       = 'Nomadic Computer Network Client in Task-Tray';
  SrcDivChar        = #9;  // {͐^u

{====================== ClientClient֑郁bZ[W =======================
BC_PN:
BC_PT:Ft
BC_PT:W1
BC_PT:W2
BC_PT:Rt
BC_SM:Ft:Sv:Message from Factory
BC_PO:Ft:T0A:0D Factory placed an order for 13 units at term 10.
BC_PS:Ft:T0A:0D Factory shipped 13 units at therm 10.

{====================== ServerClient֑郁bZ[W =======================
ؒf BS_Cl:Close
 BS_Du:Name
M BS_SM:Message
ڑ BS_Cn:Welcome!
F BS_Pl:Let''s Play!
 BS_Pl:Deny
Jn BS_Gm:Start!
ĊJ BS_Gm:ReStart!
~ BS_Gm:Pause!
I BS_Gm:Over!
 BS_PO:Received!:0D // 13󂯎
 BS_PS:Received!:0D // 13󂯎
z BS_MS:T // Manual ShipmentTrue(蓮Ŕzӎv)
iT BS_Tn:0F // 15^[ڂɂȂAIFn
Ж BS_GN:Team name
//
H BS_Ft:13
ꉵ BS_W1:10
 BS_W2:15
 BS_Rt:17
c BS_BC:18
v BS_Dm:14
 BS_Od:Ft:T // H͍s
Q BS_Jn:Ft:T // H͌(Q)
c0 BS_BC0:21
v0 BS_Dm0:22
c1 BS_BC1:23
v1 BS_Dm1:24
c2 BS_BC2:25
v2 BS_Dm2:26
c3 BS_BC3:27
v3 BS_Dm3:28
}

var
  Form_Main                  : TBeerGameClientForm;
  BasePath , IniPath ,
  DocPath  , HisPath ,
  ListPath , StartupPath     : String;
  CBackProc                  : TFarProc;
  DLLWnd                     : THandle;
  SHM_TASKBARCREATED         : UInt;
  SetLayeredWindowAttributes :
    function(hwnd : Integer; crKey : DWORD; bAlpha : Byte; dwFlags : DWORD) : Integer; stdcall;

implementation

uses
  PreviewC , BC_IniIO , Sub;

{$R *.DFM}

//------------------------------------------------------------------------------
//--------------------- ^XNgC풓̃NbN ---------------------------
procedure TBeerGameClientForm.WndProc(var Message : TMessage);
begin
  if (Message.Msg = WM_NotifyTasktray) then
  begin
    case Message.LParam of
      WM_LBUTTONDOWN : LeaveTaskTray();
      WM_RBUTTONDOWN : LeaveTaskTray();
//    WM_RBUTTONDOWN : Close();
    end;
  end
 // ^XNgC֏풓Ăꍇł^XNo[ĕ`̏ꍇ(Explorer.exe)ꍇ
  else if ((Message.Msg = SHM_TASKBARCREATED) and (Self.FInTaskTray)) then Shell_NotifyIcon(NIM_ADD , @FNotifyIcon)
  else inherited WndProc(Message);
end;

//------------------------------------------------------------------------------
//----------------------------- {O -----------------------------------
procedure TBeerGameClientForm.OnAppException(Sender : TObject; E : Exception);
begin
  Beep();
  if (MessageDlg(E.Message , mtError , [mbOK] , 0) <> mrOK) then Exit;
//06/02/15***   if (Application.MessageBox(E.Message , 'Error' , mb_OK) <> IDOK) then Exit;
// if (MessageDlg(E.Message , mtError , [mbYes] , 0) <> mrYes) then Exit;
  Application.Terminate();
end;

//------------------------------------------------------------------------------
//----------------------------- ŏ{^ -----------------------------------
procedure TBeerGameClientForm.OnMinimize(Sender : TObject);
begin
  Self.InToTaskTray(False);     // ŏ͏풓
end;

//------------------------------------------------------------------------------
//----------------------------- ^XNgC֏풓 -----------------------------
procedure TBeerGameClientForm.InToTaskTray(IsStart : Boolean);
begin
  if (not IsStart) then
  begin
    if (not MItem_TaskTray.Checked) then Exit;
    if (Self.FInTaskTray) then Exit;
  end;
  FNotifyIcon.cbSize           := SizeOf(TNotifyIconData);
  FNotifyIcon.Wnd              := Self.Handle;
  FNotifyIcon.uID              := 1;
  FNotifyIcon.uFlags           := NIF_ICON or NIF_MESSAGE or NIF_TIP;
  FNotifyIcon.uCallbackMessage := WM_NotifyTasktray;
  FNotifyIcon.hIcon            := Application.Icon.Handle;
  FNotifyIcon.szTip            := TaskTrayMsg;
  Shell_NotifyIcon(NIM_ADD , @FNotifyIcon);
  Self.FInTasktray             := True;
  Self.Hide();
end;

//------------------------------------------------------------------------------
//---------------------------- ^XNgC畜A ----------------------------
procedure TBeerGameClientForm.LeaveTaskTray();
begin
  if (not Self.FInTaskTray) then Exit;
//if (not MItem_TaskTray.Checked) then Exit;
  FNotifyIcon.cbSize := SizeOf(TNotifyIconData);
  FNotifyIcon.Wnd    := Self.Handle;
  FNotifyIcon.uID    := 1;
  Shell_NotifyIcon(NIM_DELETE , @FNotifyIcon);
  Self.FInTaskTray   := False;
  Show();                      // Ȃ2ڂHidełȂ
  Application.Restore();       // Ȃ2ڂ̍ŏ{^Ȃ
  SetWindowPos(Self.Handle , HWND_TOPMOST   , Left , Top , Width , Height , SWP_SHOWWINDOW);
  SetWindowPos(Self.Handle , HWND_NOTOPMOST , Left , Top , Width , Height , (SWP_NOSIZE or SWP_NOMOVE));
  SetForeGroundWindow(Self.Handle);
//SetActiveWindow(Self.Handle);
end;

//------------------------------------------------------------------------------
//-------------------------------- hbv --------------------------------
procedure TBeerGameClientForm.DroppedFiles(var Msg : TWMDROPFILES);
 var
  i , Files : Integer;
  TmpPath   : Array[0..MAX_PATH] of Char;
begin
  TmpPath    := '';
  Msg.Result := 0;
  Files      := DragQueryFile(Msg.Drop, Cardinal(-1) , Nil , 0); // $FFFFFFFF
  if (Files < 1) then Exit;
  for i := 0 to Files - 1 do // 1hbvꂽ̂o
    DragQueryFile(Msg.Drop , i , TmpPath , SizeOf(TmpPath));
  DragFinish(Msg.Drop);
end;

//------------------------------------------------------------------------------
//----------------------- eNXtB[h̏ -------------------------
procedure TBeerGameClientForm.InitField();
begin
  FNowTurn      := -1;
  FReceivedMsg  := '';
  FHandShipment := False;
  FClientStatus := CS_DisConnected;
  FGroupName    := '';
  FReceivedMsg  := '';
  FFactory_Stk  := 0;    // ̃^[ŎMe
  FWhole1_Stk   := 0;
  FWhole2_Stk   := 0;
  FRetail_Stk   := 0;
  FBackLog      := 0;
  FDemand       := 0;
  FOrder        := -1;
  FShipment     := -1;
  FFtEntry      := False; // ev[Qςǂ
  FW1Entry      := False;
  FW2Entry      := False;
  FRtEntry      := False;
  FFtOrder      := False; // ev[sςǂ
  FW1Order      := False;
  FW2Order      := False;
  FRtOrder      := False;
end;

//------------------------------------------------------------------------------
//----------------------------- vON -------------------------------
procedure TBeerGameClientForm.FormCreate(Sender : TObject);
 var
  TmpChar  : array[0..MAX_PATH] of Char;
  pidlPath : PItemIDList;
begin
  Application.OnException := Self.OnAppException; // O
  Application.OnMinimize  := Self.OnMinimize;     // ŏ
  SHM_TASKBARCREATED      := RegisterWindowMessage('TaskbarCreated');
  BasePath := ExtractFilePath(Application.ExeName);
  IniPath  := ChangeFileExt(Application.ExeName , '.ini');
  ListPath := ChangeFileExt(Application.ExeName , '.lst');
  DocPath  := ChangeFileExt(Application.ExeName , '.txt');
  HisPath  := ChangeFileExt(Application.ExeName , '.his');
  LoadIni(IniPath);
 // X^[gAbvpX̎擾Ƒ݊mF
  SHGetSpecialFolderLocation(Application.Handle , CSIDL_STARTUP , pidlPath);
  SHGetPathFromIDList(pidlPath , TmpChar);
  StartupPath := String(TmpChar) + '/';
 //
  InitField();
  RadioGroup_PlayClick(Self);
{
  ShowMessage(IntToStr(Integer(CS_UnKnown)));
  ShowMessage(IntToStr(Integer(CS_Disconnected)));
  ShowMessage(IntToStr(Integer(CS_Ready)));
  ShowMessage(IntToStr(Integer(CS_Join)));
  ShowMessage(IntToStr(Integer(CS_Playing)));
  ShowMessage(IntToStr(Integer(CS_Ordering)));
  ShowMessage(IntToStr(Integer(CS_GameOver)));
}
end;

//------------------------------------------------------------------------------
//----------------------- vOI(~{^) -------------------------
procedure TBeerGameClientForm.FormCloseQuery(Sender : TObject; var CanClose : Boolean);
 const
  ConfirmMsg = 'End?';
begin
  if (MItem_CloseCheck.Checked) then
  begin
    Beep();
 //06/02/15   if (MessageDlg(ConfirmMsg , mtConfirmation , [mbYes , mbCancel] , 1000) = mrCancel) then
    if (Application.MessageBox(ConfirmMsg , 'Confirmation' , mb_OKCancel) = IDCancel) then
    begin
      CanClose := False;
      Exit;
    end;
  end;
  ClientSocket.Socket.Close();
  ClientSocket.Close();
  if (DLLWnd <> 0) then FreeLibrary(DLLWnd);
  SaveIni(IniPath);
end;

//------------------------------------------------------------------------------
//-------------------------- ȉClient Socket֘A -----------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//---------------------------- T[o֐ڑ ------------------------------
procedure TBeerGameClientForm.ClientSocketConnect(Sender : TObject; Socket : TCustomWinSocket);
 var
  PlayTypeMsg : String;
begin
  Beep();
  FReceivedMsg := '';
  case (RadioGroup_Play.ItemIndex) of
    0 :  PlayTypeMsg := 'Ft';
    1 :  PlayTypeMsg := 'W1';
    2 :  PlayTypeMsg := 'W2';
    3 :  PlayTypeMsg := 'Rt';
    else PlayTypeMsg := 'UK';
  end;
  ClientSocket.Socket.SendText('BC_PN:' + Edit_Name.Text + SrcDivChar);
  ClientSocket.Socket.SendText('BC_PT:' + PlayTypeMsg    + SrcDivChar);
  FClientStatus := CS_Ready;
  FShowJoinDiag := True;
  RefreshUI();
 // Ƃ肠ڑJn͑͂Ȃ悤ɂB
  ClearFontStyle();
end;

//------------------------------------------------------------------------------
//-------------------------- T[oƐڑ؂ꂽ ----------------------------
procedure TBeerGameClientForm.ClientSocketDisconnect(Sender : TObject; Socket : TCustomWinSocket);
begin
  Beep();
  InitField();
  CheckBox_Connect.Checked := False;
  RefreshUI();
 // Ƃ肠ؒf͑͂Ȃ悤ɂB
  ClearFontStyle();
end;

//------------------------------------------------------------------------------
//------------------------- T[oւ̐ڑł̃G[ -------------------------
procedure TBeerGameClientForm.ClientSocketError(Sender : TObject; Socket : TCustomWinSocket; ErrorEvent : TErrorEvent; var ErrorCode : Integer);
 var
  ErrMsg : String;
begin
  Beep();
  case (ErrorEvent) of
    eeGeneral	 : ErrMsg := 'Socket Error';
    eeSend	 : ErrMsg := 'Socket writing error';
    eeReceive    : ErrMsg := 'Socket reading error';
    eeConnect	 : ErrMsg := 'Could not connect to the server';
    eeDisconnect : ErrMsg := 'Socket disconnection error';
    eeAccept	 : ErrMsg := 'Waiting error';
  end;
  StatusBar.SimpleText := 'ErrMsg';
  if (MessageDlg(ErrMsg , mtError , [mbOK] , 0) <> mrOK) then Exit;
 //   if (MessageDlg(ErrMsg , mtError , [mbYes] , 0) <> mrYes) then Exit;
 //06/02/15*** if (Application.MessageBox(ErrMsg , 'Error' , mb_OK) <> IDOK) then Exit;
  ErrorCode                := 0;  // ŗOG[~߂B
  FClientStatus            := CS_Disconnected;
 // ُۂƂ肠؂Ă
  CheckBox_Connect.Checked := False;
  CheckBox_ConnectClick(Self);
  RefreshUI();
end;

//------------------------------------------------------------------------------
//------------------------ T[õbZ[WM --------------------------
// {̉s => #11֒uA؂蕶(#9)s֒uĉ񐔈A1M#11s֖߂Ĉ
procedure TBeerGameClientForm.ClientSocketRead(Sender : TObject; Socket : TCustomWinSocket);
 const
  NowDivChar = #11; // {͐^u
 var
  i          : Integer;
  TmpStrList : TStringList;
  TmpStr     : String;
begin
  TmpStr := Socket.ReceiveText();
 // p
  FReceivedMsg := FReceivedMsg + TmpStr;
 // ؂蕶łȂ͎MqĂȂ̂ŘA܂ő҂B
  if (TmpStr[Length(TmpStr)] <> SrcDivChar) then Exit;

 // ꎞIɉsNowDivChar(#11)֒u
  TmpStr       := StringReplace(FReceivedMsg , #13 , NowDivChar , [rfReplaceAll]);
  FReceivedMsg := ''; // ֓nɖ߂

 // AĎMꍇAqĂ鎖̂ŁA
 // {̎M񐔂̎擾pA܂A1M = 1StringListɕ
  TmpStrList := TStringList.Create();
  try
  try
 // ꎞIɋ؂蕶(SrcDivChar = #9)sɒuTStringListP(M񐔕)ɕ
    TmpStrList.Text := StringReplace(TmpStr , SrcDivChar , #13 , [rfReplaceAll]);

   // M0͂Ȃ炳悤Ȃ
    if (TmpStrList.Count < 1) then Exit;

   // 1M֑(ꎞIɐ^u֒ûsR[hɖ߂A]֕̕ς̂)
    for i := 0 to TmpStrList.Count - 1 do
//    if (AnsiCompareText(Trim(TmpStrList.Strings[i]) , '') = 0) then Continue;
      ExtractMessages(StringReplace(TmpStrList.Strings[i] , NowDivChar , #13 , [rfReplaceAll]));
  finally
    TmpStrList.Free();
  end
  except
    raise;
  end;
end;

//------------------------------------------------------------------------------
//--------------------------- bZ[Wo -------------------------------
procedure TBeerGameClientForm.ExtractMessages(ReceivedMsgs : String);
 const
  Authorication = 'BS_';
 var
  ReceivedText      : TStringList;
  MsgType , MainStr : String;
begin
 //ShowMessage(ReceivedMsgs);
  ReceivedText := TStringList.Create();
  try
  try
    ReceivedText.Text := ReceivedMsgs;
   // 肦Ȃ낤ꉞ󔒂͂悤Ȃ()
    if (ReceivedText.Count < 1) then Exit
   // Œł7͂悤Ȃ(BS_NM:``)
    else if (Length(ReceivedText.Strings[0]) < 7) then Exit
   // 擪2BSȂ炳悤Ȃ
    else if (AnsiCompareStr(Copy(ReceivedText.Strings[0] , 1 , 3) , Authorication) <> 0) then Exit
    //else if (ReceivedText.Strings[0][6] <> ':') then Exit;  ---040826---update
   // ߒo
      //---040826---Add
        else if (AnsiCompareStr(Copy(ReceivedText.Strings[0] , 4 , 2) , 'Dm' ) = 0) then
         begin
             MsgType := Copy(ReceivedText.Strings[0] , 4 , 3);
             MainStr := Trim(Copy(ReceivedText.Text , 8 , Length(ReceivedText.Text) - 7));
         end
        else if (AnsiCompareStr(Copy(ReceivedText.Strings[0] , 4 , 2) , 'BC' ) = 0) then
         begin
             MsgType := Copy(ReceivedText.Strings[0] , 4 , 3);
             MainStr := Trim(Copy(ReceivedText.Text , 8 , Length(ReceivedText.Text) - 7));
         end
        else
         begin
      //---------------
    MsgType := Copy(ReceivedText.Strings[0] , 4 , 2);
   // {o
    MainStr := Trim(Copy(ReceivedText.Text , 7 , Length(ReceivedText.Text) - 6));
         end;
 //ShowMessage(MainStr);
   // ŃfR[hIĖߏ֓n
    ProcessMessages(MsgType , MainStr);
  finally
    ReceivedText.Free();
  end
  except
    raise;
  end;
end;

//------------------------------------------------------------------------------
//--------------------------- bZ[W -------------------------------
procedure TBeerGameClientForm.ProcessMessages(MsgType , MainStr : String);
 var
  TmpStr : String;
begin
  try
   //---------- Ӑ}ؒfꂽꍇ
    if (AnsiCompareStr(MsgType , 'Cl') = 0) then
    begin
      if (AnsiCompareStr(MainStr , 'Close') = 0) then
      begin
        Beep();
  //06/02/15      MessageDlg('Disconnected by server.' , mtInformation ,  [mbOK] , 0);
        Application.MessageBox('Disconnected by server.' , 'Information' ,  mb_OK);
        // ClientStatus ͎ۂ̐ؒfɕύX
      end;
    end

   //---------- o^]O_ȕꍇ
    else if (AnsiCompareStr(MsgType , 'Du') = 0) then
    begin
      if (AnsiCompareStr(MainStr , 'Name') = 0) then
      begin
        Beep();
   //06/02/15     MessageDlg('That name has been already used.' , mtInformation ,  [mbOK] , 0);
        Application.MessageBox('That name has been already used.' , 'Information' ,  mb_OK);
      end;
    end

   //---------- ڑmF
    else if (AnsiCompareStr(MsgType , 'Cn') = 0) then
    begin
      if (AnsiCompareStr(MainStr , 'Welcome!') = 0) then
      begin
        FClientStatus := CS_Ready;
        Beep();
  //06/02/15      MessageDlg('Connected. Waiting for acceptance.' , mtInformation ,  [mbOK] , 0);
        Application.MessageBox('Connected. Waiting for acceptance.' , 'Information' ,  mb_OK);
        RefreshUI();
        FShowJoinDiag := True;
      end;
    end

   //---------- vCE񋖉M
    else if (AnsiCompareStr(MsgType , 'Pl') = 0) then
    begin
      if (AnsiCompareStr(MainStr , 'Let''s Play!') = 0) then
      begin
        FClientStatus := CS_Join;

       // xʒmĂȂꍇMessageDlgłʒm
        if (FShowJoinDiag) then
        begin
          Beep();
   //06/02/15       MessageDlg('Accepted. Waiting for the start.' , mtInformation ,  [mbOK] , 0);
          Application.MessageBox('Accepted. Waiting for the start.' , 'Information' ,  mb_OK);
          FShowJoinDiag := False;
        end;
        RefreshUI();
      end
      else if (AnsiCompareStr(MainStr , 'Deny') = 0) then
      begin
        FClientStatus := CS_Ready;
        FHandShipment := False;
        RefreshUI();
        Beep();
   //06/02/15     MessageDlg('Cancelled' , mtInformation ,  [mbOK] , 0);
        Application.MessageBox('Cancelled' , 'Information' ,  mb_OK);
        StatusBar.SimpleText := 'Cancelled';
        FShowJoinDiag := True; // Qꂽ玟͂xʒmĂB
      end;
    end

   //---------- z̑@M BS_MS:T // (蓮Ŕzӎv)
    else if (AnsiCompareStr(MsgType , 'MS') = 0) then
    begin
      if (Length(MainStr) <> 1) then Exit;
      if      (AnsiCompareStr(MainStr , 'T') = 0) then FHandShipment := True
      else if (AnsiCompareStr(MainStr , 'F') = 0) then FHandShipment := False;
      RefreshUI();
    end

   //---------- O[vM
    else if (AnsiCompareStr(MsgType , 'GN') = 0) then
    begin
      FGroupName := MainStr;
      RefreshUI();
    end

   //---------- Q[Jn & I
    else if (AnsiCompareStr(MsgType , 'Gm') = 0) then
    begin
//    ShowMessage(MainStr);
      if (AnsiCompareStr(MainStr , 'Start!') = 0) then
      begin
        FClientStatus := CS_Playing;
        FFtOrder      := False;
        FW1Order      := False;
        FW2Order      := False;
        FRtOrder      := False;
        RefreshUI();
        Beep();
   //06/02/15     MessageDlg('Start !' , mtInformation ,  [mbOK] , 0);
        Application.MessageBox('Start !' , 'Information' ,  mb_OK);
        StatusBar.SimpleText := 'Start !';
        PageControl.ActivePageIndex := 1;
//      FShowJoinDiag := True;
      end
      else if (AnsiCompareStr(MainStr , 'ReStart!') = 0) then
      begin
        FClientStatus := CS_Playing;
        RefreshUI();
        Beep();
  //06/02/15      MessageDlg('Resumed' , mtInformation ,  [mbOK] , 0);
        Application.MessageBox('Resumed' , 'Information' ,  mb_OK);
        StatusBar.SimpleText        := 'Resumed';
        PageControl.ActivePageIndex := 1;
//      FShowJoinDiag := True;
      end
      else if (AnsiCompareStr(MainStr , 'Pause!') = 0) then
      begin
        Beep();
  //06/02/15      MessageDlg('Paused' , mtInformation ,  [mbOK] , 0);
        Application.MessageBox('Paused' , 'Information' ,  mb_OK);
        FClientStatus := CS_Pause;
        RefreshUI();
//      FShowJoinDiag := True;
      end
      else if (AnsiCompareStr(MainStr , 'Over!') = 0) then
      begin
        if (ClientSocket.Active) then CheckBox_Connect.Checked := False; // ڑ
        FClientStatus := CS_GameOver;
        FFtOrder      := False;
        FW1Order      := False;
        FW2Order      := False;
        FRtOrder      := False;
        RefreshUI();
        Beep();
   //06/02/15     MessageDlg('Finished and Disconnected' , mtInformation ,  [mbOK] , 0);
        Application.MessageBox('Finished and Disconnected' , 'Information' ,  mb_OK);
        PageControl.ActivePageIndex := 2;
        FShowJoinDiag := True;
      end;
    end

   //---------- ^[M BS_Tn:0F = 15^[ڂɂȂ
    else if (AnsiCompareStr(MsgType , 'Tn') = 0) then
    begin   // ܂ꂼ̔{^悤ɂ
      if (Length(MainStr) <> 2) then Exit;
      FClientStatus := CS_Playing; // CS_Ordering͂Ȃ̂
      FOrder        := -1;
      FShipment     := -1;
      FFtOrder      := False;
      FW1Order      := False;
      FW2Order      := False;
      FRtOrder      := False;
      LoadHistory(); // Ǎ
     // ŏI^[
      if (AnsiCompareStr(MainStr , 'Fn') = 0) then
      begin
        FShowJoinDiag := False; // I̐ؒfł܂Q[Jn҂ʒm̂(^^;)
        Inc(FNowTurn); // ̃T[oփQ[Iʒm𑗂鎞̂
        SetLength(FPlayHistory , FNowTurn); // Ō\邽߂ɗp̈g(LoadHistorył-1vZȂ̂)

       // ŏI^[̒Ɣz͂Ƃ肠00(Q[I邽)
        if (not ClientSocket.Active) then Exit;
        case (RadioGroup_Play.ItemIndex) of
          0 :
          begin
            ClientSocket.Socket.SendText('BC_PO:Ft:T' + IntToHex(FNowTurn , 2) + ':00' + SrcDivChar);
            ClientSocket.Socket.SendText('BC_PS:Ft:T' + IntToHex(FNowTurn , 2) + ':00' + SrcDivChar);
          end;
          1 :
          begin
            ClientSocket.Socket.SendText('BC_PO:W1:T' + IntToHex(FNowTurn , 2) + ':00' + SrcDivChar);
            ClientSocket.Socket.SendText('BC_PS:W1:T' + IntToHex(FNowTurn , 2) + ':00' + SrcDivChar);
          end;
          2 :
          begin
            ClientSocket.Socket.SendText('BC_PO:W2:T' + IntToHex(FNowTurn , 2) + ':00' + SrcDivChar);
            ClientSocket.Socket.SendText('BC_PS:W2:T' + IntToHex(FNowTurn , 2) + ':00' + SrcDivChar);
          end;
          3 :
          begin
            ClientSocket.Socket.SendText('BC_PO:Rt:T' + IntToHex(FNowTurn , 2) + ':00' + SrcDivChar);
            ClientSocket.Socket.SendText('BC_PS:Rt:T' + IntToHex(FNowTurn , 2) + ':00' + SrcDivChar);
          end;
        end;
//      Dec(FNowTurn); // T[oɒʒmIΓɃ^[𒴉߂Kv͂Ȃ
        RefreshUI();
        GroupBox_Game.Caption := '[' + FGroupName + '] - Status : Finished';
        StatusBar.SimpleText  := 'Finished';
      end
   // ʏ^[
      else
      begin
        FNowTurn := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
        RefreshUI();   // ϐǉŊmۂOɕ\XV(LoadHistory)
        SetLength(FPlayHistory , FNowTurn); // p̈g
      end;
    end

   //---------- H݌ɐM BS_Ft:10 = 16
    else if (AnsiCompareStr(MsgType , 'Ft') = 0) then
    begin
      if (Length(MainStr) <> 2) then Exit;
      FFactory_Stk := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
      if (High(FPlayHistory) >= (FNowTurn)) then Exit;
      FPlayHistory[FNowTurn - 1].FtStock := FFactory_Stk; // 
      RefreshUI();
    end

   //---------- ꎟ݌ɐM BS_W1:11 = 17
    else if (AnsiCompareStr(MsgType , 'W1') = 0) then
    begin
      if (Length(MainStr) <> 2) then Exit;
      FWhole1_Stk := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
      if (High(FPlayHistory) >= FNowTurn) then Exit;
      FPlayHistory[FNowTurn - 1].W1Stock := FWhole1_Stk; // 
      RefreshUI();
    end

   //---------- 񎟉݌ɐM BS_W2:12 = 18
    else if (AnsiCompareStr(MsgType , 'W2') = 0) then
    begin
      if (Length(MainStr) <> 2) then Exit;
      FWhole2_Stk := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
      if (High(FPlayHistory) >= FNowTurn) then Exit;
      FPlayHistory[FNowTurn - 1].W2Stock := FWhole2_Stk; // 
      RefreshUI();
    end

   //---------- X݌ɐM BS_Rt:13 = 19
    else if (AnsiCompareStr(MsgType , 'Rt') = 0) then
    begin
      if (Length(MainStr) <> 2) then Exit;
      FRetail_Stk := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
      if (High(FPlayHistory) >= FNowTurn) then Exit;
      FPlayHistory[FNowTurn - 1].RtStock := FRetail_Stk; // 
      RefreshUI();
    end

   //---------- 󒍎cM BS_BC:14 = 20
   // else if (AnsiCompareStr(MsgType , 'BC') = 0) then
   // begin
   //   if (Length(MainStr) <> 2) then Exit;
   //   FBackLog := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
   //   if (High(FPlayHistory) >= FNowTurn) then Exit;
   //   FPlayHistory[FNowTurn - 1].BackLog := FBackLog; // 
   //   RefreshUI();
   // end

   //---------- 󒍎cM BS_BC0:21 = 20  -----040826---Add
    else if (AnsiCompareStr(MsgType , 'BC0') = 0) then
    begin
        case (RadioGroup_Play.ItemIndex) of
          0 :
          begin
               if (Length(MainStr) <> 2) then Exit;
               FBackLog := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
               if (High(FPlayHistory) >= FNowTurn) then Exit;
               FPlayHistory[FNowTurn - 1].BackLog := FBackLog; // 
               RefreshUI();
          end;
          1 :
          begin
          end;
          2 :
          begin
          end;
          3 :
          begin
          end;
        end;
     //--------------------------------------
    end
   //---------- 󒍎cM BS_BC1:23 = 20  -----040826---Add
    else if (AnsiCompareStr(MsgType , 'BC1') = 0) then
    begin
        case (RadioGroup_Play.ItemIndex) of
          0 :
          begin
          end;
          1 :
          begin
               if (Length(MainStr) <> 2) then Exit;
               FBackLog := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
               if (High(FPlayHistory) >= FNowTurn) then Exit;
               FPlayHistory[FNowTurn - 1].BackLog := FBackLog; // 
               RefreshUI();
          end;
          2 :
          begin
          end;
          3 :
          begin
          end;
        end;
     //--------------------------------------
    end
   //---------- 󒍎cM BS_BC2:25 = 20   -----040826---Add
    else if (AnsiCompareStr(MsgType , 'BC2') = 0) then
    begin
        case (RadioGroup_Play.ItemIndex) of
          0 :
          begin
          end;
          1 :
          begin
          end;
          2 :
          begin
               if (Length(MainStr) <> 2) then Exit;
               FBackLog := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
               if (High(FPlayHistory) >= FNowTurn) then Exit;
               FPlayHistory[FNowTurn - 1].BackLog := FBackLog; // 
               RefreshUI();
          end;
          3 :
          begin
          end;
        end;
     //--------------------------------------
    end
   //---------- 󒍎cM BS_BC3:27 = 20   -----040826---Add
    else if (AnsiCompareStr(MsgType , 'BC3') = 0) then
    begin
        case (RadioGroup_Play.ItemIndex) of
          0 :
          begin
          end;
          1 :
          begin
          end;
          2 :
          begin
          end;
          3 :
          begin
               if (Length(MainStr) <> 2) then Exit;
               FBackLog := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
               if (High(FPlayHistory) >= FNowTurn) then Exit;
               FPlayHistory[FNowTurn - 1].BackLog := FBackLog; // 
               RefreshUI();
          end;
        end;
     //--------------------------------------
    end

   //---------- vM BS_Dm:15 = 21
   // else if (AnsiCompareStr(MsgType , 'Dm') = 0) then
   // begin
   //   if (Length(MainStr) <> 2) then Exit;
   //   FDemand := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
   //   if (High(FPlayHistory) >= FNowTurn) then Exit;
   //   FPlayHistory[FNowTurn - 1].Demand := FDemand; // 
   //   RefreshUI();
   // end

   //---------- 󒍐M BS_Dm0:22 = 21  -----040826---Add
    else if (AnsiCompareStr(MsgType , 'Dm0') = 0) then
    begin
   //ShowMessage(MainStr); ---040826---Add
        case (RadioGroup_Play.ItemIndex) of
          0 :
          begin
                  if (Length(MainStr) <> 2) then Exit;
                  FDemand := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
                  if (High(FPlayHistory) >= FNowTurn) then Exit;
                  FPlayHistory[FNowTurn - 1].Demand := FDemand; // 
                  RefreshUI();
          end;
          1 :
          begin
          end;
          2 :
          begin
          end;
          3 :
          begin
          end;
        end;
     //--------------------------------------
    end
   //---------- 󒍐M BS_Dm1:24 = 21  -----040826---Add
    else if (AnsiCompareStr(MsgType , 'Dm1') = 0) then
    begin
   //ShowMessage(MainStr); ---040826---Add
        case (RadioGroup_Play.ItemIndex) of
          0 :
          begin
          end;
          1 :
          begin
                  if (Length(MainStr) <> 2) then Exit;
                  FDemand := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
                  if (High(FPlayHistory) >= FNowTurn) then Exit;
                  FPlayHistory[FNowTurn - 1].Demand := FDemand; // 
                  RefreshUI();
          end;
          2 :
          begin
          end;
          3 :
          begin
          end;
        end;
     //--------------------------------------
    end
   //---------- 󒍐M BS_Dm2:26 = 21  -----040826---Add
    else if (AnsiCompareStr(MsgType , 'Dm2') = 0) then
    begin
   //ShowMessage(MainStr); ---040826---Add
        case (RadioGroup_Play.ItemIndex) of
          0 :
          begin
          end;
          1 :
          begin
          end;
          2 :
          begin
                  if (Length(MainStr) <> 2) then Exit;
                  FDemand := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
                  if (High(FPlayHistory) >= FNowTurn) then Exit;
                  FPlayHistory[FNowTurn - 1].Demand := FDemand; // 
                  RefreshUI();
          end;
          3 :
          begin
          end;
        end;
     //--------------------------------------
    end
   //---------- 󒍐M BS_Dm3:28 = 21  -----040826---Add
    else if (AnsiCompareStr(MsgType , 'Dm3') = 0) then
    begin
   //ShowMessage(MainStr); ---040826---Add
        case (RadioGroup_Play.ItemIndex) of
          0 :
          begin
          end;
          1 :
          begin
          end;
          2 :
          begin
          end;
          3 :
          begin
                  if (Length(MainStr) <> 2) then Exit;
                  FDemand := StrToIntDef('$' + Copy(MainStr , 1 , 2) , -1);
                  if (High(FPlayHistory) >= FNowTurn) then Exit;
                  FPlayHistory[FNowTurn - 1].Demand := FDemand; // 
                  RefreshUI();
          end;
        end;
     //--------------------------------------
    end

   //----------  󒍂̕ԎM  BS_PO:Received!:0D = 13󂯎
    else if (AnsiCompareStr(MsgType , 'PO') = 0) then
    begin
      if (Length(MainStr) <> 12) then Exit;
      if (AnsiCompareStr(Copy(MainStr , 1 , 10) , 'Received!:') <> 0) then Exit;
     // Ǝ󒍐̏ƍĂĂ痚
      case (RadioGroup_Play.ItemIndex) of
        0..3 :
        begin
          if (FOrder <> StrToIntDef('$' + Copy(MainStr , 11 , 2) , -1)) then Exit;
//        ShowMessage(IntToStr(High(FPlayHistory)) + ' / ' + IntToStr(FNowTurn));
          if (High(FPlayHistory) >= FNowTurn) then Exit;
          FPlayHistory[FNowTurn - 1].Order := FOrder; // 
          RefreshUI();
        end;
      end;
    end
  
   //---------- z 󒍂̕ԎM  BS_PS:Received!:0D = 13󂯎
    else if (AnsiCompareStr(MsgType , 'PS') = 0) then
    begin
      if (Length(MainStr) <> 12) then Exit;
      if (AnsiCompareStr(Copy(MainStr , 1 , 10) , 'Received!:') <> 0) then Exit;
     // zw萔Ǝۂ̔z̏ƍ͂Ȃ
      case (RadioGroup_Play.ItemIndex) of
        0..3 :
        begin
          FShipment := StrToIntDef('$' + Copy(MainStr , 11 , 2) , -1);
          if (High(FPlayHistory) >= FNowTurn) then Exit;
          FPlayHistory[FNowTurn - 1].Shipment := FShipment; // 
          RefreshUI();
        end;
      end;
    end

   //---------- QςǂM BS_Jn:Ft:T // H͎Q
    else if (AnsiCompareStr(MsgType , 'Jn') = 0) then
    begin
      if (Length(MainStr) <> 4) then Exit;
      if (MainStr[3] <> ':')    then Exit;
      TmpStr := Copy(MainStr , 1 , 2);
      if      (AnsiCompareText(TmpStr , 'Ft') = 0) then
      begin
        case (MainStr[4]) of
          'T' : FFtEntry := True;
          'F' : FFtEntry := False;
        end;
      end
      else if (AnsiCompareText(TmpStr , 'W1') = 0) then
      begin
        case (MainStr[4]) of
          'T' : FW1Entry := True;
          'F' : FW1Entry := False;
        end;
      end
      else if (AnsiCompareText(TmpStr , 'W2') = 0) then
      begin
        case (MainStr[4]) of
          'T' : FW2Entry := True;
          'F' : FW2Entry := False;
        end;
      end
      else if (AnsiCompareText(TmpStr , 'Rt') = 0) then
      begin
        case (MainStr[4]) of
          'T' : FRtEntry := True;
          'F' : FRtEntry := False;
        end;
      end;
      SetEntryLabels(); // ς݃xXV
    end

   //----------- sςǂM BS_Od:Ft:T // H͍s
    else if (AnsiCompareStr(MsgType , 'Od') = 0) then
    begin
      if (Length(MainStr) <> 4) then Exit;
      if (MainStr[3] <> ':')    then Exit;
      TmpStr := Copy(MainStr , 1 , 2);
      if      (AnsiCompareText(TmpStr , 'Ft') = 0) then
      begin
        case (MainStr[4]) of
          'T' : FFtOrder := True;
          'F' : FFtOrder := False;
        end;
      end
      else if (AnsiCompareText(TmpStr , 'W1') = 0) then
      begin
        case (MainStr[4]) of
          'T' : FW1Order := True;
          'F' : FW1Order := False;
        end;
      end
      else if (AnsiCompareText(TmpStr , 'W2') = 0) then
      begin
        case (MainStr[4]) of
          'T' : FW2Order := True;
          'F' : FW2Order := False;
        end;
      end
      else if (AnsiCompareText(TmpStr , 'Rt') = 0) then
      begin
        case (MainStr[4]) of
          'T' : FRtOrder := True;
          'F' : FRtOrder := False;
        end;
      end;
      SetOrderLabels(); // ς݃xXV
    end
  
     //---------- bZ[WM
    else if (AnsiCompareStr(MsgType , 'SM') = 0) then
    begin
      Beep();
      MessageDlg(Trim(MainStr) , mtInformation ,  [mbOK] , 0);
//06/02/15***      Application.MessageBox(Trim(MainStr) , 'Information' ,  mb_OK);
    end;
  except
  //ShowMessage('a');
  end;
end;
//---------------------- Client\PbgʐM֘A܂ ------------------------
//------------------------------------------------------------------------------








//------------------------------------------------------------------------------
//-------------------------- ȉCj[֘A ----------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//-------------------- Q[j[NbNEnabled -----------------------
procedure TBeerGameClientForm.Menu_GameClick(Sender : TObject);
begin
  MItem_Connect.Enabled := CheckBox_Connect.Enabled;
  MItem_Connect.Checked := CheckBox_Connect.Checked;
  case (RadioGroup_Play.ItemIndex) of
    0 : MItem_Order.Enabled  := Button_FtOrder.Enabled;
    1 : MItem_Order.Enabled  := Button_W1Order.Enabled;
    2 : MItem_Order.Enabled  := Button_W2Order.Enabled;
    3 : MItem_Order.Enabled  := Button_RtOrder.Enabled;
    else MItem_Order.Enabled := False;
  end;
  MItem_SendMsg.Enabled := Button_SendMsg.Enabled;
  MItem_Save.Enabled    := (ListView_History.Items.Count > 0);
end;

//------------------------------------------------------------------------------
//--------------------- ҏWj[NbNEnabled ------------------------
procedure TBeerGameClientForm.Menu_EditClick(Sender: TObject);
begin
  MItem_Copy.Enabled   := (ListView_History.SelCount    > 0);
  MItem_SelAll.Enabled := (ListView_History.Items.Count > 0);
end;

//------------------------------------------------------------------------------
//-------------------- wvj[NbNEnabled -----------------------
procedure TBeerGameClientForm.Menu_HelpClick(Sender : TObject);
begin
  MItem_StartUp.Checked := FileExists(StartupPath + Application.Title + '.lnk');
  MItem_Doc    .Enabled := FileExists(DocPath);
  MItem_History.Enabled := FileExists(HisPath);
end;

//------------------------------------------------------------------------------
//-------------------------- |bvAbvEnabled -----------------------------
procedure TBeerGameClientForm.PopupMenu_ListViewPopup(Sender: TObject);
begin
  PItem_Save.Enabled   := (ListView_History.Items.Count > 0);
  PItem_Copy.Enabled   := (ListView_History.SelCount    > 0);
  PItem_SelAll.Enabled := (ListView_History.Items.Count > 0);
end;

//------------------------------------------------------------------------------
//------------------------------- T[o֐ڑ ---------------------------------
procedure TBeerGameClientForm.MItem_ConnectClick(Sender: TObject);
begin
  CheckBox_Connect.Checked := (not CheckBox_Connect.Checked);
//CheckBox_ConnectClick(Self);
end;

//------------------------------------------------------------------------------
//------------------------------ Q[ʕۑ --------------------------------
procedure TBeerGameClientForm.MItem_SaveClick(Sender : TObject);
 var
  i          : Integer;
  ColumnStr  : String;
  TmpStrList : TStringList;
begin
  PageControl.ActivePageIndex := 2;
  if (not SaveDialog.Execute()) then Exit;
  TmpStrList := TStringList.Create();
  try
  try
    MItem_SelAllClick(Self);
    TmpStrList.Text := ListView_CpyToClp(ListView_History , FColumnDivStr , True);
   // ږ쐬
    ColumnStr := '';
    for i := 0 to ListView_History.Columns.Count - 1 do
    begin
      if (i = (ListView_History.Columns.Count - 1)) then
        ColumnStr := ColumnStr + ListView_History.Columns.Items[i].Caption
      else
        ColumnStr := ColumnStr + ListView_History.Columns.Items[i].Caption + FColumnDivStr;
    end;
   // 擪ɍڍs}(󔒂Ȃꍇ(؂蕶󔒂ɒuʂ󔒂Ȃꍇ))
    if (AnsiCompareStr(StringReplace(ColumnStr , FColumnDivStr , '' , [rfReplaceAll]) , '') <> 0) then
      TmpStrList.Insert(0 , ColumnStr);
    TmpStrList.SaveToFile(SaveDialog.FileName);
  finally
    TmpStrList.Free();
  end
  except
  //raise;
  end;
end;


//------------------------------------------------------------------------------
//----------------------------------- I -------------------------------------
procedure TBeerGameClientForm.MItem_ExitClick(Sender : TObject);
begin
  Self.Close();
end;

//------------------------------------------------------------------------------
//------------------------------ sRs[ --------------------------------
procedure TBeerGameClientForm.MItem_CopyClick(Sender : TObject);
begin
  ListView_CpytoClp(ListView_History , FColumnDivStr);
end;

//------------------------------------------------------------------------------
//----------------------------- sSđI -------------------------------
procedure TBeerGameClientForm.MItem_SelAllClick(Sender : TObject);
 var
  i : Integer;
begin
  for i := 0 to ListView_History.Items.Count - 1 do ListView_History.Items.Item[i].Selected := True
end;

//------------------------------------------------------------------------------
//--------------------------------- tHg -----------------------------------
procedure TBeerGameClientForm.MItem_FontClick(Sender : TObject);
begin       // PageControl(yюq̃y[W)ւ̃tHg̐ݒ
  FontDialog.Font.Assign(Font);
  if (not FontDialog.Execute()) then Exit;
  Font.Assign(FontDialog.Font);
end;

//------------------------------------------------------------------------------
//------------------------------ X^[gAbv --------------------------------
procedure TBeerGameClientForm.MItem_StartUpClick(Sender : TObject);
 var
  ShellLink    : IShellLink;
  PersistFile  : IPersistFile;
  LinkFileName : String;
begin
  MItem_Startup.Checked := (not MItem_Startup.Checked);
  LinkFileName := StartupPath + Application.Title + '.lnk';             // V[gJbgt@C̍쐬
  if (MItem_StartUp.Checked) then
  begin
    if (not FileExists(LinkFileName)) then
    begin
      ShellLink    := CreateComObject(CLSID_ShellLink) as IShellLink;       // V[gJbgpCOMIuWFNg쐬
      PersistFile  := ShellLink as IPersistFile;                            // V[gJbgt@CpIuWFNg
      ShellLink.SetArguments('/TaskTray');                                  // R}hCp[^
      ShellLink.SetPath(PChar(Application.ExeName));                        // ΏExẽtpX
      ShellLink.SetWorkingDirectory(PChar(BasePath));                       // ƃtH_
      OleCheck(PersistFile.Save(PWChar(WideString(LinkFileName)) , False)); // t@C쐬
      Beep();
//06/02/15      MessageDlg('Start up is enabled.' , mtInformation ,  [mbOK] , 0);
      Application.MessageBox('Start up is enabled.' , 'Information' ,  mb_OK);
    end;
  end
  else
  begin
    if (FileExists(LinkFileName)) then
    begin
      DeleteFile(LinkFileName);
      Beep();
//06/02/15      MessageDlg('Start up is disabled..' , mtInformation ,  [mbOK] , 0);
      Application.MessageBox('Start up is disabled..' , 'Information' ,  mb_OK);
    end;
  end;
end;

//------------------------------------------------------------------------------
//------------------- e탁j[Checked(ʂ܂) ------------------------
procedure TBeerGameClientForm.MItem_CheckClick(Sender : TObject);
begin
 // ʓ
  if (not (Sender is TMenuItem)) then Exit;
  (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked;
 // ʓ(ɍőO)
  if (Sender = MItem_StayFront) then
  begin
    if (MItem_StayFront.Checked) then SetWindowPos(Handle , HWND_TOPMOST   , Left , Top , Width , Height , SWP_SHOWWINDOW)
    else                              SetWindowPos(Handle , HWND_NOTOPMOST , Left , Top , Width , Height , (SWP_NOSIZE or SWP_NOMOVE));
  end;
end;

//------------------------------------------------------------------------------
//------------------------------ teLXg ----------------------------------
procedure TBeerGameClientForm.MItem_DocClick(Sender : TObject);
begin
  Form_Preview.Memo.Clear();
  Form_Preview.Caption := Application.Title + ' - Text - ' + ExtractFileName(DocPath);
  Form_Preview.Memo.Lines.LoadFromFile(DocPath);
  Form_Preview.ShowModal();
  Form_Preview.Memo.Clear();
end;

//------------------------------------------------------------------------------
//-------------------------------- XV ------------------------------------
procedure TBeerGameClientForm.MItem_HistoryClick(Sender : TObject);
begin
  Form_Preview.Memo.Clear();
  Form_Preview.Caption := Application.Title + ' - Renewal history - ' + ExtractFileName(HisPath);
  Form_Preview.Memo.Lines.LoadFromFile(HisPath);
  Form_Preview.ShowModal();
  Form_Preview.Memo.Clear();
end;

//------------------------------------------------------------------------------
//----------------------------- o[W ---------------------------------
procedure TBeerGameClientForm.MItem_InfoClick(Sender : TObject);
 var
  MemStat : TMemoryStatus;
  Msg     : TStringList;
begin
  MemStat.dwLength := SizeOf(TMemoryStatus);
  GlobalMemoryStatus(MemStat);
  Msg := TStringList.Create();
  try
  try
 //06/02/15   Msg.Add('u' + Application.Title + 'v' + Version + Date);
    Msg.Add('[Nomadic Computer Network Beer Game Client]' + Version + Date);
    Msg.Add('');
    Msg.Add('Your machine: ' + GetMachineType());
    Msg.Add('Free memory: ' + FormatFloat('#,##0' , MemStat.dwAvailPhys) + ' / ' + FormatFloat('#,##0' , MemStat.dwTotalPhys) + ' bytes');
    Msg.Add('');
    Msg.Add('Handle Name    => Kun (Yukinori Sone)');
    Msg.Add('E-Mail Address => x-master@kun.ne.jp');
    Msg.Add('@@@or@@@ => x-sone@gakushuin.ac.jp');
    Msg.Add('Web-Page URL   => http://www5.airnet.ne.jp/kun/');
    MessageDlg(Msg.Text , mtInformation ,  [mbOK] , 0);
 //06/02/15***   Application.MessageBox(Msg.Text , 'Information' ,  mb_OK);
  finally
    Msg.Free();
  end
  except
    raise;
  end;
end;
//------------------------ ܂ŃCj[֘A --------------------------
//------------------------------------------------------------------------------





{------------------------------------------------------------------------------}
{---------------------- ڑ^u-֘ACxgn -----------------------}
{------------------------------------------------------------------------------}

//------------------------------------------------------------------------------
//------------------------------ T[o֐ڑ ----------------------------------
procedure TBeerGameClientForm.CheckBox_ConnectClick(Sender : TObject);
begin
 // ڑ̃`FbNꂽꍇ
  if (CheckBox_Connect.Checked) then
  begin
    if (ClientSocket.Active) then  ClientSocket.Close(); // Ô
    try
      ClientSocket.Host        := Edit_Server.Text;
      ClientSocket.Port        := SpinEdit_Port.Value;
      ClientSocket.Open();
      CheckBox_Connect.Enabled := False;  // OnConnectŐmFEnableɖ߂
      FClientStatus            := CS_Ready;
      RefreshUI();
    except
      FClientStatus := CS_Disconnected;
//06/02/15      MessageDlg('Error! Can''t Establish Connection..' , mtError ,  [mbOK] , 0);
      Application.MessageBox('Error! Can''t Establish Connection..' , 'Error' ,  mb_OK);
      RefreshUI();
//    raise;
    end;
  end
  else // ؒfꍇ
  begin
    FClientStatus := CS_Disconnected;
    RefreshUI();
    SpinEdit_Port.Enabled := True;
    ClientSocket.Close();
  end;
end;

//------------------------------------------------------------------------------
//------------------------- vC[^CvI -------------------------------
procedure TBeerGameClientForm.RadioGroup_PlayClick(Sender : TObject);
begin
  RefreshUI();
end;

//------------------------------------------------------------------------------
//----------------------------- bZ[WM ---------------------------------
procedure TBeerGameClientForm.Button_SendMsgClick(Sender : TObject);
 var
  FromStr   : String;
  TargetStr : String;
begin
  if (not ClientSocket.Active) then Exit;
  if (AnsiCompareText(Trim(Memo_Msg.Lines.Text) , '') = 0) then Exit;
  case (RadioGroup_Play.ItemIndex) of
    0 : FromStr := 'Ft';
    1 : FromStr := 'W1';
    2 : FromStr := 'W2';
    3 : FromStr := 'Rt';
    else Exit;
  end;
  case (RadioGroup_Target.ItemIndex) of
    0 : TargetStr := 'Ft';
    1 : TargetStr := 'W1';
    2 : TargetStr := 'W2';
    3 : TargetStr := 'Rt';
    4 : TargetStr := 'Sv';
    else Exit;
  end;
  SendText(ClientSocket.Socket , 'BC_SM:' + FromStr + ':' + TargetStr + ':' + Memo_Msg.Lines.Text);
//ClientSocket.Socket.SendText('BC_SM:' + FromStr + ':' + TargetStr + ':' + Memo_Msg.Lines.Text + SrcDivChar);
  Beep();
//06/02/15 MessageDlg('Send a Message.' , mtInformation ,  [mbOK] , 0);
  Application.MessageBox('Send a Message.' , 'Information' ,  mb_OK);
  Memo_Msg.Clear();
end;
{------------------------------------------------------------------------------}
{---------------------- ܂Őڑ^u-֘ACxgn -----------------------}
{------------------------------------------------------------------------------}





{------------------------------------------------------------------------------}
{------------------------ Q[^u-Cxg -------------------------}
{------------------------------------------------------------------------------}

//------------------------------------------------------------------------------
//------------------------------- {^ -----------------------------------
procedure TBeerGameClientForm.Button_OrderClick(Sender : TObject);
 var
  FromStr   : String;
begin
  if (not ClientSocket.Active) then Exit;
 // e{^
  if      (Sender = Button_FtOrder) then
  begin
    FOrder    := SpinEdit_FtOrder.Value;
    FShipment := SpinEdit_FtShipM.Value;
  end
  else if (Sender = Button_W1Order) then
  begin
    FOrder    := SpinEdit_W1Order.Value;
    FShipment := SpinEdit_W1ShipM.Value;
  end
  else if (Sender = Button_W2Order) then
  begin
    FOrder    := SpinEdit_W2Order.Value;
    FShipment := SpinEdit_W2ShipM.Value;
  end
  else if (Sender = Button_RtOrder) then
  begin
    FOrder    := SpinEdit_RtOrder.Value;
    FShipment := SpinEdit_RtShipM.Value;
  end;
 // M
  case (RadioGroup_Play.ItemIndex) of
    0 : FromStr := 'Ft';
    1 : FromStr := 'W1';
    2 : FromStr := 'W2';
    3 : FromStr := 'Rt';
    else Exit;
  end;
  ClientSocket.Socket.SendText('BC_PO:' + FromStr + ':T' + IntToHex(FNowTurn , 2) + ':' + IntToHex(FOrder    , 2) + SrcDivChar);
  if (FHandShipment) then
    ClientSocket.Socket.SendText('BC_PS:' + FromStr + ':T' + IntToHex(FNowTurn , 2) + ':' + IntToHex(FShipment , 2) + SrcDivChar);
  FClientStatus := CS_Ordering;
  RefreshUI();
end;
{------------------------------------------------------------------------------}
{------------------------- ܂ŃQ[^u-Cxg ------------------------}
{------------------------------------------------------------------------------}




{------------------------------------------------------------------------------}
{-------------------------- 痚^u-Cxg -------------------------}
{------------------------------------------------------------------------------}

//------------------------------------------------------------------------------
//----------- IsNbv{[hփRs[(NotClip͖߂lɂ) ------------
function TBeerGameClientForm.ListView_CpytoClp(ListView : TListView; ColumnDivStr : String; NotClip : Boolean) : String;
 var
  i , j      : Integer;
  TmpLineStr : String;
  TmpStrList : TStringList;
begin
  if (ListView = Nil) then Exit;
  if (ListView.Items.Count < 1) then Exit;
  if (ListView.SelCount < 1) then Exit;
  TmpStrList := TStringList.Create();
  try
  try
    for j := 0 to ListView.Items.Count - 1 do
    begin
      if (ListView.Items.Item[j].Selected) then  // I𒆂̍ŝ݂𔲐ăNbv{[hփRs[
      begin
        TmpLineStr := ListView.Items.Item[j].Caption;
       // ڐ؂蕶ŋ؂Ēǉ
        if (ListView.Items.Item[j].SubItems.Count < 1) then Continue;
        for i := 0 to ListView.Items.Item[j].SubItems.Count - 1 do
          TmpLineStr := TmpLineStr + ColumnDivStr + ListView.Items.Item[j].SubItems.Strings[i];
        TmpStrList.Add(TmpLineStr);
      end;
    end;
   // NotClip̃tOŌʂNbv{[h߂l̂ꂩŕԂ
    if (TmpStrList.Count > 0) then
    begin
      if (NotClip) then           Result := TmpStrList.Text
      else              ClipBoard.AsText := TmpStrList.Text;
    end;
  finally
    TmpStrList.Free();
  end
  except
    raise;
  end;
end;

//------------------------------------------------------------------------------
//--------------------------- ListViewł̃L[ -----------------------------
procedure TBeerGameClientForm.ListView_KeyDown(Sender : TObject; var Key : Word; Shift : TShiftState);
begin
  if (not (Sender is TListView)) then Exit;
  if ((Sender as TListView).Items.Count < 1) then Exit;
 // ReturnŃ_uNbN(eHandlê)
  if      (Key = VK_RETURN) then
 // DelőIs폜
  else if (Key = VK_DELETE) then
 // Ctrl + AőSI
  else if ((ssCtrl in Shift) and (Key = Ord('A'))) then MItem_SelAllClick(Self)
  else if ((ssCtrl in Shift) and (Key = Ord('C'))) then ListView_CpytoClp((Sender as TListView) , FColumnDivStr)
  else if ((ssCtrl in Shift) and (Key = Ord('Z'))) then
  else if ((ssCtrl in Shift) and (Key = Ord('X'))) then
  else if ((ssCtrl in Shift) and (Key = Ord('V'))) then ;
end;
{------------------------------------------------------------------------------}
{-------------------------- ܂ŗ^u-Cxg -------------------------}
{------------------------------------------------------------------------------}






//------------------------------------------------------------------------------
//------------------ UIԌnƂʂ̑[` --------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//----------------------------- eSpinEdit -------------------------------
procedure TBeerGameClientForm.SpinEdit_Exit(Sender : TObject);
begin
 // ʓ
  if      (not (Sender is TSpinEdit)) then Exit;
  if      (TSpinEdit(Sender).Text = '') then TSpinEdit(Sender).Value := TSpinEdit(Sender).MinValue
  else if (Length(TSpinEdit(Sender).Text) > TSpinEdit(Sender).MaxLength) then TSpinEdit(Sender).Value := TSpinEdit(Sender).MaxValue
  else if (TSpinEdit(Sender).Value < TSpinEdit(Sender).MinValue) then TSpinEdit(Sender).Value := TSpinEdit(Sender).MinValue
  else if (TSpinEdit(Sender).Value > TSpinEdit(Sender).MaxValue) then TSpinEdit(Sender).Value := TSpinEdit(Sender).MaxValue;
 // ʓ
  if (Sender = SpinEdit_Port) then ClientSocket.Port := SpinEdit_Port.Value;
end;

//------------------------------------------------------------------------------
//------------------ e󋵃x̃tHg̑̉ ------------------------
procedure TBeerGameClientForm.ClearFontStyle();
begin
  if (fsBold in Label_FtInput.Font.Style) then Label_FtInput.Font.Style := Label_FtInput.Font.Style - [fsBold];
  if (fsBold in Label_W1Input.Font.Style) then Label_W1Input.Font.Style := Label_W1Input.Font.Style - [fsBold];
  if (fsBold in Label_W2Input.Font.Style) then Label_W2Input.Font.Style := Label_W2Input.Font.Style - [fsBold];
  if (fsBold in Label_RtInput.Font.Style) then Label_RtInput.Font.Style := Label_RtInput.Font.Style - [fsBold];
  if (fsBold in Label_FtJoin.Font.Style)  then Label_FtJoin.Font.Style  := Label_FtJoin.Font.Style  - [fsBold];
  if (fsBold in Label_W1Join.Font.Style)  then Label_W1Join.Font.Style  := Label_W1Join.Font.Style  - [fsBold];
  if (fsBold in Label_W2Join.Font.Style)  then Label_W2Join.Font.Style  := Label_W2Join.Font.Style  - [fsBold];
  if (fsBold in Label_RtJoin.Font.Style)  then Label_RtJoin.Font.Style  := Label_RtJoin.Font.Style  - [fsBold];
end;

//------------------------------------------------------------------------------
//---------------------------- Q`FbN --------------------------------
procedure TBeerGameClientForm.SetEntryLabels();
begin
 // H Q
  if (not FFtEntry) then
  begin
    if      (fsBold in Label_FtJoin.Font.Style)  then
      Label_FtJoin.Font.Style := Label_FtJoin.Font.Style - [fsBold];
    Label_FtJoin.Caption      := 'Factory : Waiting';
  end
  else
  begin
    if (not (fsBold in Label_FtJoin.Font.Style)) then
      Label_FtJoin.Font.Style := Label_FtJoin.Font.Style + [fsBold];
    Label_FtJoin.Caption      := 'Factory : Fulfilled';
  end;
 // ꎟ Q
  if (not FW1Entry) then
  begin
    if      (fsBold in Label_W1Join.Font.Style)  then
      Label_W1Join.Font.Style := Label_W1Join.Font.Style - [fsBold];
    Label_W1Join.Caption      := 'Distributor : Waiting';
  end
  else
  begin
    if (not (fsBold in Label_W1Join.Font.Style)) then
      Label_W1Join.Font.Style := Label_W1Join.Font.Style + [fsBold];
    Label_W1Join.Caption      := 'Distributor : Fulfilled';
  end;
 // 񎟉 Q
  if (not FW2Entry) then
  begin
    if      (fsBold in Label_W2Join.Font.Style)  then
      Label_W2Join.Font.Style := Label_W2Join.Font.Style - [fsBold];
    Label_W2Join.Caption      := 'Wholesaler : Waiting';
  end
  else
  begin
    if (not (fsBold in Label_W2Join.Font.Style)) then
      Label_W2Join.Font.Style := Label_W2Join.Font.Style + [fsBold];
    Label_W2Join.Caption      := 'Wholesaler : Fulfilled';
  end;
 // X Q
  if (not FRtEntry) then
  begin
    if      (fsBold in Label_RtJoin.Font.Style)  then
      Label_RtJoin.Font.Style := Label_RtJoin.Font.Style - [fsBold];
    Label_RtJoin.Caption      := 'Retailer : Waiting';
  end
  else
  begin
    if (not (fsBold in Label_RtJoin.Font.Style)) then
      Label_RtJoin.Font.Style := Label_RtJoin.Font.Style + [fsBold];
    Label_RtJoin.Caption      := 'Retailer : Fulfilled';
  end;
end;

//------------------------------------------------------------------------------
//------------- ̈ӎvǂ`FbNăx -------------
procedure TBeerGameClientForm.SetOrderLabels();
begin
 // H sϏ
  if (FFtOrder) then
  begin
    if (not (fsBold in Label_FtInput.Font.Style)) then
      Label_FtInput.Font.Style := Label_FtInput.Font.Style + [fsBold];
    Label_FtInput.Caption      := 'Factory : Ordered';
  end
  else
  begin
    if      (fsBold in Label_FtInput.Font.Style)  then
      Label_FtInput.Font.Style := Label_FtInput.Font.Style - [fsBold];
    Label_FtInput.Caption      := 'Factory : Notyet';
  end;
 // ꎟ sϏ
  if (FW1Order) then
  begin
    if (not (fsBold in Label_W1Input.Font.Style)) then
      Label_W1Input.Font.Style := Label_W1Input.Font.Style + [fsBold];
    Label_W1Input.Caption      := 'Distributor : Ordered';
  end
  else
  begin
    if      (fsBold in Label_W1Input.Font.Style)  then
      Label_W1Input.Font.Style := Label_W1Input.Font.Style - [fsBold];
    Label_W1Input.Caption      := 'Distributor : Notyet';
  end;
 // 񎟉 sϏ
  if (FW2Order) then
  begin
    if (not (fsBold in Label_W2Input.Font.Style)) then
      Label_W2Input.Font.Style := Label_W2Input.Font.Style + [fsBold];
    Label_W2Input.Caption      := 'Wholesaler : Ordered';
  end
  else
  begin
    if      (fsBold in Label_W2Input.Font.Style)  then
      Label_W2Input.Font.Style := Label_W2Input.Font.Style - [fsBold];
    Label_W2Input.Caption      := 'Wholesaler : Notyet';
  end;
 // X sϏ
  if (FRtOrder) then
  begin
    if (not (fsBold in Label_RtInput.Font.Style)) then
      Label_RtInput.Font.Style := Label_RtInput.Font.Style + [fsBold];
    Label_RtInput.Caption      := 'Retailer : Ordered';
  end
  else
  begin
    if      (fsBold in Label_RtInput.Font.Style)  then
      Label_RtInput.Font.Style := Label_RtInput.Font.Style - [fsBold];
    Label_RtInput.Caption      := 'Retailer : Notyet';
  end;
end;

//------------------------------------------------------------------------------
//------------------- eR|[lgVisiblëꊇ ----------------------
procedure TBeerGameClientForm.RefreshUIVisible();
begin
 // v[[^Cvʍڂ̏
  Label_FtDemand.Visible   := (RadioGroup_Play.ItemIndex = 0);
  Label_FtBLCost.Visible   := (RadioGroup_Play.ItemIndex = 0);
  Label_FtOrder.Visible    := (RadioGroup_Play.ItemIndex = 0);
  Label_FtShipM.Visible    := (RadioGroup_Play.ItemIndex = 0);
  Label_W1Demand.Visible   := (RadioGroup_Play.ItemIndex = 1);
  Label_W1BLCost.Visible   := (RadioGroup_Play.ItemIndex = 1);
  Label_W1Order.Visible    := (RadioGroup_Play.ItemIndex = 1);
  Label_W1ShipM.Visible    := (RadioGroup_Play.ItemIndex = 1);
  Label_W2Demand.Visible   := (RadioGroup_Play.ItemIndex = 2);
  Label_W2BLCost.Visible   := (RadioGroup_Play.ItemIndex = 2);
  Label_W2Order.Visible    := (RadioGroup_Play.ItemIndex = 2);
  Label_W2ShipM.Visible    := (RadioGroup_Play.ItemIndex = 2);
  Label_RtDemand.Visible   := (RadioGroup_Play.ItemIndex = 3);
  Label_RtBLCost.Visible   := (RadioGroup_Play.ItemIndex = 3);
  Label_RtOrder.Visible    := (RadioGroup_Play.ItemIndex = 3);
  Label_RtShipM.Visible    := (RadioGroup_Play.ItemIndex = 3);
  SpinEdit_FtOrder.Visible := (RadioGroup_Play.ItemIndex = 0);
  SpinEdit_W1Order.Visible := (RadioGroup_Play.ItemIndex = 1);
  SpinEdit_W2Order.Visible := (RadioGroup_Play.ItemIndex = 2);
  SpinEdit_RtOrder.Visible := (RadioGroup_Play.ItemIndex = 3);
  SpinEdit_FtShipM.Visible := (RadioGroup_Play.ItemIndex = 0);
  SpinEdit_W1ShipM.Visible := (RadioGroup_Play.ItemIndex = 1);
  SpinEdit_W2ShipM.Visible := (RadioGroup_Play.ItemIndex = 2);
  SpinEdit_RtShipM.Visible := (RadioGroup_Play.ItemIndex = 3);
  Button_FtOrder.Visible   := (RadioGroup_Play.ItemIndex = 0);
  Button_W1Order.Visible   := (RadioGroup_Play.ItemIndex = 1);
  Button_W2Order.Visible   := (RadioGroup_Play.ItemIndex = 2);
  Button_RtOrder.Visible   := (RadioGroup_Play.ItemIndex = 3);
end;

//------------------------------------------------------------------------------
//------------------- eR|[lgEnabled̈ꊇ ----------------------
procedure TBeerGameClientForm.RefreshUIEnabled();
begin
 // ڑQ[ݒn
  Edit_Server.Enabled      := ((FClientStatus <= CS_Disconnected) or (FClientStatus = CS_GameOver));
  SpinEdit_Port.Enabled    := ((FClientStatus <= CS_Disconnected) or (FClientStatus = CS_GameOver));
  Edit_Name.Enabled        := ((FClientStatus <= CS_Disconnected) or (FClientStatus = CS_GameOver));
  RadioGroup_Play.Enabled  := ((FClientStatus <= CS_Disconnected) or (FClientStatus = CS_GameOver));
  CheckBox_Connect.Enabled := ((FClientStatus <= CS_Ready)        or (FClientStatus = CS_GameOver));

 // Q
  GroupBox_Join.Enabled := (FClientStatus >= CS_Ready);
  Label_FtJoin.Enabled  := (FClientStatus >= CS_Ready);
  Label_W1Join.Enabled  := (FClientStatus >= CS_Ready);
  Label_W2Join.Enabled  := (FClientStatus >= CS_Ready);
  Label_RtJoin.Enabled  := (FClientStatus >= CS_Ready);

 // bZ[WMn
  Label_Msg.Enabled         := (FClientStatus >= CS_Ready);
  Memo_Msg.Enabled          := (FClientStatus >= CS_Ready);
  RadioGroup_Target.Enabled := (FClientStatus >= CS_Ready);
  Button_SendMsg.Enabled    := (FClientStatus >= CS_Ready);

 // e(ڑłEnabled)
  GroupBox_Game.Enabled := (FClientStatus >= CS_Ready);
  Label_Factory.Enabled := (FClientStatus >= CS_Ready);
  Label_Whole1.Enabled  := (FClientStatus >= CS_Ready);
  Label_Whole2.Enabled  := (FClientStatus >= CS_Ready);
  Label_Retail.Enabled  := (FClientStatus >= CS_Ready);
  Label_Marcket.Enabled := (FClientStatus >= CS_Ready);
  Label_Cursor1.Enabled := (FClientStatus >= CS_Ready);
  Label_Cursor2.Enabled := (FClientStatus >= CS_Ready);
  Label_Cursor3.Enabled := (FClientStatus >= CS_Ready);
  Label_Cursor4.Enabled := (FClientStatus >= CS_Ready);

 // v[[̏񍀖(Q󂯂Enabled)
  Label_FtStock.Enabled  := (FClientStatus >= CS_Join);
  Label_W1Stock.Enabled  := (FClientStatus >= CS_Join);
  Label_W2Stock.Enabled  := (FClientStatus >= CS_Join);
  Label_RtStock.Enabled  := (FClientStatus >= CS_Join);
  Label_FtDemand.Enabled := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 0));
  Label_FtBLCost.Enabled := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 0));
  Label_FtOrder.Enabled  := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 0));
  Label_FtShipM.Enabled  := ((FHandShipment) and (FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 0));
  Label_W1Demand.Enabled := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 1));
  Label_W1BLCost.Enabled := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 1));
  Label_W1Order.Enabled  := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 1));
  Label_W1ShipM.Enabled  := ((FHandShipment) and (FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 1));
  Label_W2Demand.Enabled := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 2));
  Label_W2BLCost.Enabled := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 2));
  Label_W2Order.Enabled  := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 2));
  Label_W2ShipM.Enabled  := ((FHandShipment) and (FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 2));
  Label_RtDemand.Enabled := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 3));
  Label_RtBLCost.Enabled := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 3));
  Label_RtOrder.Enabled  := ((FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 3));
  Label_RtShipM.Enabled  := ((FHandShipment) and (FClientStatus >= CS_Join) and (RadioGroup_Play.ItemIndex = 3));
   // SpinEdit̐l͂l
  SpinEdit_FtOrder.Enabled := ((FClientStatus >= CS_Join) and (FClientStatus < CS_GameOver) and (RadioGroup_Play.ItemIndex = 0));
  SpinEdit_W1Order.Enabled := ((FClientStatus >= CS_Join) and (FClientStatus < CS_GameOver) and (RadioGroup_Play.ItemIndex = 1));
  SpinEdit_W2Order.Enabled := ((FClientStatus >= CS_Join) and (FClientStatus < CS_GameOver) and (RadioGroup_Play.ItemIndex = 2));
  SpinEdit_RtOrder.Enabled := ((FClientStatus >= CS_Join) and (FClientStatus < CS_GameOver) and (RadioGroup_Play.ItemIndex = 3));
  SpinEdit_FtShipM.Enabled := ((FHandShipment) and (FClientStatus >= CS_Join) and (FClientStatus < CS_GameOver) and (RadioGroup_Play.ItemIndex = 0));
  SpinEdit_W1ShipM.Enabled := ((FHandShipment) and (FClientStatus >= CS_Join) and (FClientStatus < CS_GameOver) and (RadioGroup_Play.ItemIndex = 1));
  SpinEdit_W2ShipM.Enabled := ((FHandShipment) and (FClientStatus >= CS_Join) and (FClientStatus < CS_GameOver) and (RadioGroup_Play.ItemIndex = 2));
  SpinEdit_RtShipM.Enabled := ((FHandShipment) and (FClientStatus >= CS_Join) and (FClientStatus < CS_GameOver) and (RadioGroup_Play.ItemIndex = 3));

 // {^
  Button_FtOrder.Enabled := ((FClientStatus = CS_Playing) and (RadioGroup_Play.ItemIndex = 0));
  Button_W1Order.Enabled := ((FClientStatus = CS_Playing) and (RadioGroup_Play.ItemIndex = 1));
  Button_W2Order.Enabled := ((FClientStatus = CS_Playing) and (RadioGroup_Play.ItemIndex = 2));
  Button_RtOrder.Enabled := ((FClientStatus = CS_Playing) and (RadioGroup_Play.ItemIndex = 3));

 // ӎvς݂ǂ̃x
  GroupBox_Input.Enabled := (FClientStatus >= CS_Playing);
  Label_FtInput.Enabled  := (FClientStatus >= CS_Playing);
  Label_W1Input.Enabled  := (FClientStatus >= CS_Playing);
  Label_W2Input.Enabled  := (FClientStatus >= CS_Playing);
  Label_RtInput.Enabled  := (FClientStatus >= CS_Playing);
end;

//------------------------------------------------------------------------------
//--------------------------------- Ǎ -----------------------------------
procedure TBeerGameClientForm.LoadHistory();
 var
  i         : Integer;
  TmpLstItm : TListItem;
begin
  if (Length(FPlayHistory) < 2) then Exit;
  ListView_History.Items.BeginUpdate();
  ListView_History.Items.Clear();
  for i := 0 to High(FPlayHistory) - 1 do // sI^[܂ŕ\̂-1(^[͂܂\Ȃ)
  begin
    TmpLstItm         := ListView_History.Items.Add();
    TmpLstItm.Caption := IntToStr(i + 1);
    TmpLstItm.SubItems.Add(IntToStr(FPlayHistory[i].FtStock));
    TmpLstItm.SubItems.Add(IntToStr(FPlayHistory[i].W1Stock));
    TmpLstItm.SubItems.Add(IntToStr(FPlayHistory[i].W2Stock));
    TmpLstItm.SubItems.Add(IntToStr(FPlayHistory[i].RtStock));
    TmpLstItm.SubItems.Add(IntToStr(FPlayHistory[i].BackLog));
    TmpLstItm.SubItems.Add(IntToStr(FPlayHistory[i].Demand));
    TmpLstItm.SubItems.Add(IntToStr(FPlayHistory[i].Order));
    TmpLstItm.SubItems.Add(IntToStr(FPlayHistory[i].Shipment));
  end;
  ListView_History.Items.EndUpdate();
 //
end;


//------------------------------------------------------------------------------
//------------------ Q[̏Wvf[^ListViewփ[h ----------------------
procedure TBeerGameClientForm.ResultDataToListView();
 var
  i , j     : Integer;
  Sum       : Currency;
  TmpLstItm : TListItem;
begin
  if (FClientStatus <> CS_GameOver) then Exit;

  ListView_History.Items.BeginUpdate();
  if (ListView_History.Items.Count < 1)   then Exit;
  if (ListView_History.Columns.Count < 2) then Exit;

 // v̎Zo
  TmpLstItm         := ListView_History.Items.Add();
  TmpLstItm.Caption := 'Total';
  for j := 1 to ListView_History.Columns.Count - 1 do // T͂Ȃ1
  begin
    Sum := 0;
    for i := 0 to ListView_History.Items.Count - 2 do // Add-2ɂ
      Sum := Sum + StrToFloat(ListView_History.Items.Item[i].SubItems.Strings[j - 1]);  // Caption͂Ȃ-1ł傤SubItem
    TmpLstItm.SubItems.Add(CurrToStr(Sum));
  end;

  TmpLstItm         := ListView_History.Items.Add();
  TmpLstItm.Caption := 'Average';
  for j := 1 to ListView_History.Columns.Count - 1 do // T͂Ȃ1
  begin
    Sum := StrToFloat(ListView_History.Items.Item[ListView_History.Items.Count - 2].SubItems.Strings[j - 1]);
    TmpLstItm.SubItems.Add(CurrToStr(Sum / (ListView_History.Items.Count - 2)));
  end;

  ListView_History.Items.EndUpdate();
end;


//------------------------------------------------------------------------------
//------------------------ Enabled Visiblëꊇ ---------------------------
procedure TBeerGameClientForm.RefreshUI();
begin
  SetEntryLabels(); // Qς݃xXV
  SetOrderLabels(); // ς݃xXV
  RefreshUIVisible();
  RefreshUIEnabled();
  LoadHistory();
 // eQ[ԕ
  case (FClientStatus) of
    CS_UnKnown      : Exit;
    CS_Disconnected :
    begin
      StatusBar.SimpleText := 'disconnected.';
    end;
    CS_Ready        :
    begin
      StatusBar.SimpleText := 'Connected. Waiting for acceptance.';
    end;
    CS_Join         :
    begin
      StatusBar.SimpleText := 'Accepted. Waiting for the start.';
    end;
    CS_Playing      :
    begin
      StatusBar.SimpleText  := ' (' + IntToStr(FNowTurn) + 'Week)';
      GroupBox_Game.Caption := 'u' + FGroupName + 'v - Status : ' + IntToStr(FNowTurn) + ' Week';
      Label_FtStock.Caption := 'Factorys current inventory     : ' + IntToStr(FFactory_Stk);
      Label_W1Stock.Caption := 'Distributors current inventory : ' + IntToStr(FWhole1_Stk);
      Label_W2Stock.Caption := 'Wholesalers current inventory  : ' + IntToStr(FWhole2_Stk);
      Label_RtStock.Caption := 'Retailers current inventory    : ' + IntToStr(FRetail_Stk);
      case (RadioGroup_Play.ItemIndex) of
        0 :
        begin
          Label_FtBLCost.Caption := 'Lastweek backlog : ' + IntToStr(FBackLog);
          Label_FtDemand.Caption := 'Receive an order from Distributor: ' + IntToStr(FDemand);
        end;
        1 :
        begin
          Label_W1BLCost.Caption := 'Lastweek backlog : ' + IntToStr(FBackLog);
          Label_W1Demand.Caption := 'Receive an order from Wholesaler: ' + IntToStr(FDemand);
        end;
        2 :
        begin
          Label_W2BLCost.Caption := 'Lastweek backlog : ' + IntToStr(FBackLog);
          Label_W2Demand.Caption := 'Receive an order from Retailer: ' + IntToStr(FDemand);
        end;
        3 :
        begin
          Label_RtBLCost.Caption := 'Lastweek backlog : ' + IntToStr(FBackLog);
          Label_RtDemand.Caption :=   'Demand in market : ' + IntToStr(FDemand);
        end;
      end;
    end;
    CS_Pause        :
    begin
      StatusBar.SimpleText := 'Paused';
    end;
    CS_Ordering     :
    begin
      StatusBar.SimpleText  := ' (' + IntToStr(FNowTurn) + 'Week) - Waiting for another player.';
    end;
    CS_GameOver     :
    begin
      ResultDataToListView();
      StatusBar.SimpleText  := 'FinishedI';
      GroupBox_Game.Caption := 'u' + FGroupName + 'v - Status : FinishedI';
    end;
  end;
end;

//------------------------------------------------------------------------------
//------------------------- Ŝ߂̕M -------------------------------
procedure TBeerGameClientForm.SendText(const Socket : TCustomWinSocket; const SendText : String; const UnitLength : Byte; const DivChar : Char);
 var
  NowUnitLength     : Byte;
  i , NowPos        : Integer;
  UnitStr , LineStr : String;
  StrList           : TStringList;
begin
  if (Socket = Nil)   then Exit;
  if (UnitLength = 0) then Exit;
  StrList := TStringList.Create();
  try
  try
    StrList.Text := SendText;
    if (StrList.Count < 1) then Exit;
   // 1sM
    for i := 0 to StrList.Count - 1 do
    begin
      NowPos := 1;
     // wPʂ̕M
      while (NowPos < Length(StrList.Strings[i])) do
      begin
        LineStr := StrList.Strings[i];
        NowUnitLength := UnitLength; // Ƃ肠{MPʒ

       // ̍s̎c̒MPʂZ瑗MPʂsb^c̕ɂB
        if ((Length(LineStr) - (NowPos - 1)) < NowUnitLength) then
          NowUnitLength := Length(LineStr) - (NowPos - 1);

       // ]Pʂ̍Ō̕Sp̑O1Byteꍇ͓]Pʂ1Byte炷
        if ( ByteType(LineStr , (NowPos + NowUnitLength - 1)) = mbLeadByte) then Dec(NowUnitLength);
       // ]̐؏oƓ]
        UnitStr := Copy(StrList.Strings[i] , NowPos , NowUnitLength);
        Socket.SendText(UnitStr);
        Inc(NowPos , NowUnitLength); // |WVi߂
      end;
     // sɉsR[ht
      Socket.SendText(#13); // #1310?ɂȂĂ܂̂
    end;
   // Ōɂ͏IR[ht
    Socket.SendText(DivChar);
  finally
    StrList.Free();
  end
  except
  //raise;
  end;
end;

//------------------------------------------------------------------------------
//  ̑\
// GUIɐFB

//------------------------------------------------------------------------------
end.
